package org.processmining.blocklayout.algorithms;

import java.util.Set;

import org.processmining.blocklayout.models.reductions.Reduction;
import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.parameters.LayoutParameters;

public interface FinderAlgorithm {

	/**
	 * Return the set of suitable reductions for the given net.
	 * 
	 * @param net The given net.
	 * @return The set of suitable reductions for the given net.
	 */
	Set<Reduction> find(StateMachineNet net, LayoutParameters layoutParameters);
	
}
