package org.processmining.blocklayout.algorithms;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.processmining.blocklayout.models.reductions.Reduction;
import org.processmining.blocklayout.models.reductions.TransitionReduction;
import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.models.statemachine.Transition;
import org.processmining.blocklayout.parameters.LayoutParameters;

public class ReverseTransitionFinderAlgorithm implements FinderAlgorithm {

	public Set<Reduction> find(StateMachineNet net, LayoutParameters layoutParameters) {
		Set<Reduction> reductions = new HashSet<Reduction>();
		for (Transition backwardTransition : net.getTransitionList()) {
			if (net.getPostset(net.getPostPlace(backwardTransition)).size() == 1
					&& net.getPreset(net.getPrePlace(backwardTransition)).size() == 1) {
				for (Transition forwardTransition : net.getPostset(net.getPostPlace(backwardTransition))) {
					if (backwardTransition != forwardTransition) {
						if (net.getPostPlace(forwardTransition) == net.getPrePlace(backwardTransition)) {
							List<Transition> transitions = new ArrayList<Transition>();
							transitions.add(forwardTransition);
							Reduction reduction = new TransitionReduction(backwardTransition, transitions, true);
							reductions.add(reduction);
							return reductions;
						}
					}
				}
			}
		}
		return reductions;
	}

}
