package org.processmining.blocklayout.algorithms;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import org.processmining.blocklayout.models.reductions.Reduction;
import org.processmining.blocklayout.models.reductions.TransitionReduction;
import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.models.statemachine.Transition;
import org.processmining.blocklayout.parameters.LayoutParameters;

public class SelfLoopTransitionFinderAlgorithm implements FinderAlgorithm {

	public Set<Reduction> find(StateMachineNet net, LayoutParameters layoutParameters) {
		Set<Reduction> reductions = new HashSet<Reduction>();
		for (Transition transition : net.getTransitionList()) {
			if (net.getPrePlace(transition) == net.getPostPlace(transition)) {
				Reduction reduction = new TransitionReduction(transition, new ArrayList<Transition>(), true);
				reductions.add(reduction);
				return reductions;
			}
		}
		return reductions;
	}

}
