package org.processmining.blocklayout.models.blocks;

import org.processmining.blocklayout.parameters.LayoutParameters;

public class DummyBlock extends AbstractBlock {

	private Block block;
	
	/**
	 * The dummy block takes the same dimensions as its child blocks,
	 * but does not set any position sin the child block. As a result,
	 * it is simply occupying a similar space.
	 * 
	 * @param block
	 */
	public DummyBlock(Block block) {
		this.block = block;
	}
	
	public void setPosition(double positionX, double positionY, boolean isLeftToRight,
			LayoutParameters layoutParameters) {
		// Do nothing.
	}

	public double getTopHeight(LayoutParameters layoutParameters) {
		return block.getTopHeight(layoutParameters);
	}

	public double getBottomHeight(LayoutParameters layoutParameters) {
		return block.getBottomHeight(layoutParameters);
	}

	public double getWidth(LayoutParameters layoutParameters) {
		return block.getWidth(layoutParameters);
	}

	public int getNofLayers() {
		return block.getNofLayers();
	}

	public String getName() {
		return "";
	}

}
