package org.processmining.blocklayout.models.reductions;

import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.parameters.LayoutParameters;

public interface Reduction {

	/**
	 * Returns the costs of applying this reduction on the given net. 
	 * 
	 * @param net
	 *            The given net.
	 * @return The costs of applying the reduction on the given net.
	 */
	public int costs(StateMachineNet net, LayoutParameters layoutParameters);

	/**
	 * Applies this reduction to the given net.
	 * 
	 * @param net
	 *            The given net.
	 * @param layoutParameters
	 *            Parameters including, among others, the horizontal space
	 *            between element blocks.
	 */
	public void apply(StateMachineNet net, LayoutParameters layoutParameters);

}
