package org.processmining.blocklayout.plugins;

import org.processmining.blocklayout.algorithms.ReductionAlgorithm;
import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

public class ReductionPlugin extends ReductionAlgorithm {

	@Plugin(name = "Apply a single reduction rule (in-place)", returnLabels = {
			"Reduced state machine Petri net" }, returnTypes = { StateMachineNet.class }, parameterLabels = {
					"State machien net" }, help = "Apply a single reduction to a state machine Petri net", userAccessible = true)
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(requiredParameterLabels = { 0 })
	public StateMachineNet runOnce(PluginContext context, StateMachineNet net) {
		reduceOnce(net, new LayoutParameters());
		return net;
	}

	@Plugin(name = "Apply free reduction rules (in-place)", returnLabels = {
			"Reduced state machine Petri net" }, returnTypes = { StateMachineNet.class }, parameterLabels = {
					"State machien net" }, help = "Apply a single reduction to a state machine Petri net", userAccessible = true)
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(requiredParameterLabels = { 0 })
	public StateMachineNet runFree(PluginContext context, StateMachineNet net) {
		LayoutParameters layoutParameters = new LayoutParameters();
		/*
		 * Allow only reductions that cost 0.
		 */
		layoutParameters.setCostsThreshold(0);
		reduce(net, layoutParameters);
		return net;
	}

}
