package org.processmining.blocklayout.plugins;

import javax.swing.JComponent;

import org.processmining.blocklayout.models.statemachine.StateMachineNet;
import org.processmining.blocklayout.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.ViewSpecificAttributeMap;
import org.processmining.models.jgraph.ProMJGraphVisualizer;

@Plugin(name = "@0 Visualize State Machine Net", level = PluginLevel.Regular, returnLabels = {
		"Visualized State Machine Net" }, returnTypes = {
				JComponent.class }, parameterLabels = { "State Machine Net" }, userAccessible = true)
@Visualizer
public class StateMachineNetVisualizerPlugin {

	@PluginVariant(requiredParameterLabels = { 0 })
	public static JComponent visualize(UIPluginContext context, StateMachineNet net) {
		return visualize((PluginContext) context, net);
	}

	public static JComponent visualize(PluginContext context, StateMachineNet net) {
		return ProMJGraphVisualizer.instance().visualizeGraph(context, net.createPetriNet(new LayoutParameters()),
				new ViewSpecificAttributeMap());
	}
}
